/*
 * ADC16_ADS1115.c
 *
 *  Created on: 2012-8-4
 *      Author: Administrator
 */
#include"ADC16_ADS1115.h"
#include"delay.h"

#define I2C_SCL_OUT P1DIR |= BIT5	//SCLΪ
#define I2C_SCL_H P1OUT |= BIT5	//SCL1
#define I2C_SCL_L P1OUT &= ~BIT5	//SCL0

#define I2C_SDA_IN P1DIR &= ~BIT4	//SDAΪ
#define I2C_SDA_OUT P1DIR |= BIT4	//SDAΪ
#define I2C_SDA_H P1OUT |= BIT4	//SDA1
#define I2C_SDA_L P1OUT &= ~BIT4	//SDA0
#define I2C_SDA_IS_H P1IN & BIT4	//SDAΪ1
#define I2C_SDA_IS_L ~(P1IN & BIT4)	//SDAΪ0

/*  ʱߣSCLΪߵƽ䣬ߣSDAɸ߱ͣһʼźš-------*/
static void I2CStart();
/*  ʱߣSCLΪߵƽ䣬ߣSDAɵͱߣһֹͣźš-------*/
static void I2CStop();
//һֽ
static void WriteByte(u8 byte);
//һֽ
static u8 ReadByte();
/*					*/
static u8 TestAck(void);
static void NoAck();
static void Ack();
static void Delay5us(volatile u16 time)
{
	while(time--);
}
/*ADS1115ʼ*/
void ADS1115Init()
{
	I2C_SCL_OUT;	//ʱΪ
	I2C_SDA_OUT;		//Ϊ

	I2C_SCL_H;		//SCL1
	I2C_SDA_H;		//SDA1
}
/*ADS1115*/
void Confige1115(u8 channel,u8 pga_gain,u8 mode,u8 data_rate)
{
	I2CStart();
	WriteByte(ADC_ADDR << 1);			//дָ+ַ
	TestAck();
	WriteByte(CONFIG_ADDR);				//ָüĴ
	TestAck();
	WriteByte(0x80 | channel | pga_gain | mode);//òͨPGA棬ģʽ
	TestAck();
	WriteByte(0x03 | data_rate);				//ò
	TestAck();
	I2CStop();
}
/*ָӦĴ*/
void PointRegister(u8 _register)
{
	I2CStart();
	WriteByte(ADC_ADDR << 1);				//дָ+ַ
	TestAck();
	WriteByte(_register);					//ָָĴ
	TestAck();
	I2CStop();
}
/*һ*/
u16 ADCSample()
{
	u16 data = 0;

	I2CStart();
	WriteByte((ADC_ADDR << 1) + 0x01);		//ָ+ַ
	TestAck();
	data = ReadByte();						//8λ
	Ack();
	data = (data << 8) | ReadByte();		//8λ
	NoAck();//TestAck();
	I2CStop();
	return data;
}
/*1115жصתɵѹֵ*/
double VoltageConvert(u16 data,u8 pga_gain)
{
	double voltage = 0,full_scale = 1;
	switch(pga_gain)						//õ
	{
	case PGA_2_3:full_scale = 6.144;break;
	case PGA_1	:full_scale = 4.096;break;
	case PGA_2	:full_scale = 2.048;break;
	case PGA_4	:full_scale = 1.024;break;
	case PGA_8	:full_scale = 0.512;break;
	case PGA_16	:full_scale = 0.256;break;
	}
	if(data > 0x7fff)						//øѹ
	{
		data = ~data + 1;
		if(data == 0) data = 0x7fff;
		voltage = -(data / 32768.0 * full_scale);
		return voltage;
	}
	else									//ѹ
	{
		voltage = data / 32768.0 * full_scale;
		return voltage;
	}

}

/*  ʱߣSCLΪߵƽ䣬ߣSDAɸ߱ͣһʼźš-------*/
void I2CStart()
{

	I2C_SDA_H;
	Delay5us(5);
	I2C_SCL_H;
	Delay5us(5);
	I2C_SDA_L;
	Delay5us(5);
	I2C_SCL_L;
}
/*  ʱߣSCLΪߵƽ䣬ߣSDAɵͱߣһֹͣźš-------*/
void I2CStop()
{
	I2C_SCL_L;
	I2C_SDA_L;
	Delay5us(5);
	I2C_SCL_H;
	Delay5us(5);
	I2C_SDA_H;
	Delay5us(25);
	//I2C_SCL_L;

}
//һֽ
void WriteByte(u8 byte)
{
	u8 i;
	for(i = 0;i < 8;i++)
	{
		if(byte & (0x80 >> i)) I2C_SDA_H;
		else I2C_SDA_L;
		Delay5us(1);
		I2C_SCL_H;
		Delay5us(5);
		I2C_SCL_L;
		Delay5us(5);
	}
}
//һֽ
u8 ReadByte()
{
	u8 i,byte = 0;
	I2C_SDA_H;
	I2C_SDA_IN;
	for(i = 0;i < 8;i++)
	{
		I2C_SCL_L;
		Delay5us(5);
		I2C_SCL_H;
		Delay5us(5);
		if(I2C_SDA_IS_H) byte |= (0x80 >> i);
		else byte &= ~(0x80 >> i);
		Delay5us(5);
		I2C_SCL_L;
		Delay5us(5);
	}
	I2C_SDA_OUT;
	return byte;
}

/*-------------------------Ӧ----------------------------------------*/
void Ack()
{
	I2C_SDA_L;
	_nop();
	I2C_SCL_H;
	Delay5us(5);
	I2C_SCL_L;
	Delay5us(5);
	I2C_SDA_H;
}
/*-----------------------Ӧ---------------------------------------------*/
void NoAck()
{
	I2C_SCL_L;
	I2C_SDA_H;
	I2C_SCL_H;
	Delay5us(5);
	I2C_SCL_L;
	Delay5us(5);
}
/*		Ӧ			*/
u8 TestAck(void)
{
	u8 ErrorBit;

	I2C_SCL_L;
	//I2C_SDA_H;
	I2C_SDA_IN;
	Delay5us(1);
	I2C_SCL_H;
	Delay5us(1);
	ErrorBit = I2C_SDA_IS_H;
	I2C_SDA_OUT;
	Delay5us(1);
	I2C_SCL_L;
	Delay5us(1);
	return(ErrorBit);
}



