/*
 * ADC16_ADS1115.h
 *
 *  Created on: 2012-8-4
 *      Author: Administrator
 */

#ifndef ADC16_ADS1115_H_
#define ADC16_ADS1115_H_

#include"msp430g2452.h"

#define u8 unsigned char
#define u16 unsigned short

#define ADC_ADDR 0x48			//ADS1115 address
#define CONVERSION_ADDR	0x00	//Conversion register address
#define CONFIG_ADDR	0x01		//Config register address
#define LO_THRESH_ADDR	0x02		//Lo_thresh register address
#define HI_THRESH_ADDR	0x03		//Hi_thresh register address

#define CH0 0x40	//AINP = AIN0 and AINN = GND
#define CH1 0x50	//AINP = AIN1 and AINN = GND
#define CH2 0x60	//AINP = AIN2 and AINN = GND
#define CH3 0x70	//AINP = AIN3 and AINN = GND
#define CH0_1 0x00	//AINP = AIN0 and AINN = AIN1
#define CH0_3 0x10	//AINP = AIN0 and AINN = AIN3
#define CH1_3 0x20	//AINP = AIN1 and AINN = AIN3
#define CH2_3 0x30	//AINP = AIN2 and AINN = AIN3

#define PGA_2_3	0x00	//PGA gain 2/3(FS=+-6.144V)
#define PGA_1	0x02	//PGA gain 1(FS=+-4.096V)
#define PGA_2   0x04	//PGA gain 2(FS=+-2.048V)
#define PGA_4	0x06	//PGA gain 4(FS=+-1.024V)
#define PGA_8	0x08	//PGA gain 8(FS=+-0.512V)
#define PGA_16	0x0a	//PGA gain 16(FS=+-0.256V)

#define M_CC 	0x00	//continuous conversion mode
#define M_PD	0x01	//power down single shot mode

#define	DR_8	0x00	//8SPS
#define DR_16	0x20	//16SPS
#define DR_32	0x40	//32SPS
#define DR_64	0x60	//64SPS
#define DR_128	0x80	//128SPS
#define DR_250	0x90	//250SPS
#define DR_475  0xc0	//475SPS
#define DR_860	0xe0	//860SPS




/*ADS1115ʼ*/
void ADS1115Init();
/*ADS1115*/
void Confige1115(u8 channel,u8 pga_gain,u8 mode,u8 data_rate);
/*ָӦĴ*/
void PointRegister(u8 _register);
/*ADS1115*/
u16 ADCSample();
/*1115жصתɵѹֵ*/
double VoltageConvert(u16 data,u8 pga_gain);

#endif /* ADC16_ADS1115_H_ */
