/*
 * LCD12864.c
 *
 *  Created on: 2012-7-15
 *      Author: Administrator
 */

#include"LCD12864.h"
#include"delay.h"
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<msp430g2452.h>
/*ʱ*/

/*һֽ*/
void SendByte(u8 byte)
{
	u8 i;
	SID_OUT_ON;
	SCLK_OUT_ON;
	for(i = 0;i < 8;i++)
	{
		if((byte << i) & 0x80) SID_H;
		else SID_L;
		SCLK_L;
		DelayUs(5);
		SCLK_H;
	}
}
/*һֽ*/
u8 ReadByte()
{
	u8 i,byte;
	SID_OUT_OFF;
	SCLK_OUT_ON;
	for(i = 0;i < 8;i++)
	{
		SCLK_L;
		DelayUs(10);
		SCLK_H;
		DelayUs(10);
		if(SID_IS_H) byte |= (0x80 >> i);
	}
	SID_OUT_ON;
	return byte;
}
/**/
void WriteCmd(u8 cmd)
{
	DelayUs(10);
	SendByte(0xf8);					//ʼֽ
	SendByte(cmd & 0xf0);			//λ
	SendByte((cmd << 4) & 0xf0);	//λ
}
/**/
void WriteData(u8 dat)
{
	SendByte(0xfa);					//ʼֽ
	SendByte(dat & 0xf0);			//ݸλ
	SendByte((dat << 4) & 0xf0);	//ݵλ
}
/**/
void SetXY(u8 x,u8 y)
{

	x /= 16;
	if(y > 31)
	{
		x += 0x08;
		y = y - 32;
	}
	WriteCmd(0x80 | y);
	WriteCmd(0x80 | x);

}
/**/
/*u16 ReadData(u8 x,u8 y)
{
	u16 data;
	DelayUs(10);

	SetXY(x,y);
	SendByte(0xfe);					//ʼֽ
	ReadByte();
	data = ReadByte();
	data <<= 8;
	data |= ReadByte();
	return data;
}*/

/**/
void SetPos(u8 row,u8 column)
{
	u8 pos;
	switch(row)
	{
		case 1:pos = column - 1;break;
		case 2:pos = 16 + column - 1;break;
		case 3:pos = 8 + column - 1;break;
		case 4:pos = 24 + column - 1;
		default:return;
	}
	WriteCmd(0x80 | pos);
}
/*ʾַ*/
void PutStr(char* str,u8 row,u8 column)
{
	char* p = str;
	WriteCmd(0x02);
	SetPos(row,column);					//趨
	SendByte(0xfa);						//ʼֽ
	while(*p != '\0')
	{
		SendByte(*p & 0xf0);			//ݸλ
		SendByte((*p << 4) & 0xf0);		//ݵλ
		p++;
	}
}
/**/
void CLS()
{
	WriteCmd(0x01);
}
/*ʼ12864*/
void InitLcd()
{
	WriteCmd(0x30);
	WriteCmd(0x30);			//ָΣ
	WriteCmd(0x0c);			//ʾرչ
	//WriteCmd(0x06);		//,AC1
	//WriteCmd(0x02);		//ַλ
	//WriteCmd(0x80);		//趨ʾ
	WriteCmd(0x01);			//

}
/*ͼƬ壬*/
/*void ClearBmp()
{
	u8 i,j,k;
	WriteCmd(0x34);			//ָ
	for(k = 0;k < 2;k++)
	{
		for(j = 0;j < 32;j++)
		{
			WriteCmd(0x80 | j);		//趨y
			WriteCmd(0x80 | (k * 0x08));		//趨x
			for(i = 0;i < 16;i++)
			{
				WriteData(0x00);
			}
		}
	}
	WriteCmd(0x36);			//ͼʾ
	WriteCmd(0x30);			//ָ
}
/*void DrawBmp(u8 const* bmp)
{
	u8 i,j,k;
	WriteCmd(0x34);			//ָ
	for(k = 0;k < 2;k++)
	{

		for(j = 0;j < 32;j++)
		{
			WriteCmd(0x80 | j);		//趨y
			WriteCmd(0x80 | (k * 0x08));		//趨x
			for(i = 0;i < 16;i++)
			{
				WriteData(*bmp++);
			}
		}
	}
	WriteCmd(0x36);			//ͼʾ
	WriteCmd(0x30);			//ָ
}
/**/
/*void PlotPoint(u8 x,u8 y)
{
	u16 temp = 0x00;
	WriteCmd(0x34);			//ָ
	temp = ReadData(x,y);	//ȡԭ

	temp |= (0x8000 >> (x % 16));
	SetXY(x,y);
	WriteData((u8)(temp >> 8));
	WriteData((u8)temp);

	WriteCmd(0x36);			//ͼʾ
	WriteCmd(0x30);			//ָ

}*/

void PutFloat(float Voltage,u8 row,u8 column)
{
	char data_str[8];
	char a[3];
	char b[5];
	int i,k;
	k=Voltage*10000.0;
	ltoa((int)Voltage,a);
	for(i=3;i>=0;i--)
	{
		b[i]=k%10+'0';
		k=k/10;
	}
	b[4]='\0';
	strcpy(data_str,a);
	strcat(data_str,".");
	strcat(data_str,b);
	WriteCmd(0x02);
	PutStr(data_str,row,column);

}

